class JoinCheck : public ClientUser
{
    public:

	JoinCheck( ClientApi* api, Error* e );
	~JoinCheck();

	void LoadProtect( StrPtr* user = 0 );
	void LoadBranch( StrPtr* branch = 0 );
	void LoadClient( StrPtr* client = 0 );

	void DoJoins();

	MapApi *FullJoin() { return joinPBC; }

	int MaxWild( MapApi* view );

	void OutputStat( StrDict *varList );

	void DumpViews();
	void DumpView( MapApi *view );

    private:

	ClientApi* api;
	Error* e;

	char state; // 'p', 'b', or 'c'
		
	MapApi protect;
	MapApi branch;
	MapApi client;
	
	MapApi *joinPB;
	MapApi *joinPBC;
};
